import Result from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import { IAnimationEaseFunction } from '@pilotlab/animation';
import AudioCache from './audioCache';
import AudioManager from './audioManager';
import Animation from "@pilotlab/animation/src/animation";
export declare class AudioSource {
    constructor(audioManager: AudioManager, url: string, cache?: AudioCache, isCache?: boolean);
    protected p_audioManager: AudioManager;
    protected p_buffer: AudioBuffer;
    protected p_url: string;
    protected p_source: AudioBufferSourceNode;
    protected p_isStarted: boolean;
    protected p_isStopped: boolean;
    protected p_isDisconnected: boolean;
    protected p_isLoading: boolean;
    protected p_gainNode: GainNode;
    protected p_endFadeDuration: number;
    protected p_endFadeEase: IAnimationEaseFunction;
    protected p_startedAtMilliseconds: number;
    protected p_pausedAtMilliseconds: number;
    readonly isLoaded: boolean;
    protected p_isLoaded: boolean;
    readonly isPaused: boolean;
    volume: number;
    readonly duration: number;
    loaded: Signal<AudioSource>;
    ended: Signal<AudioSource>;
    endFadeStarted: Signal<AudioSource>;
    playbackStarted: Signal<AudioSource>;
    paused: Signal<AudioSource>;
    load(url: string, cache?: AudioCache, isCache?: boolean): Result<AudioSource>;
    readonly elapsedMilliseconds: number;
    tick(elapsedMilliseconds: number): void;
    protected p_animGain: Animation;
    play(bFromBeginning?: boolean, duration?: number, ease?: IAnimationEaseFunction, isLoop?: boolean): AudioSource;
    pause(duration?: number, isUseManagerVolume?: boolean, ease?: IAnimationEaseFunction): boolean;
    stop(duration?: number, isUseManagerVolume?: boolean, ease?: IAnimationEaseFunction): AudioSource;
    fade(duration: number, from?: number, to?: number, ease?: IAnimationEaseFunction): Result<AudioSource>;
    fadeAtEnd(duration?: number, ease?: IAnimationEaseFunction): void;
    private _setupBuffer();
}
export default AudioSource;
